/**
 * gclc:fr.bigeon.gclc.command.CommandTestingApplication.java
 * Created on: Jun 12, 2016
 */
package fr.bigeon.gclc;

import java.io.IOException;
import java.io.InputStream;
import java.io.PipedInputStream;
import java.io.PipedOutputStream;
import java.io.PrintWriter;

import fr.bigeon.gclc.command.ICommand;
import fr.bigeon.gclc.exception.InvalidCommandName;
import fr.bigeon.gclc.manager.SystemConsoleManager;

/**
 * <p>
 * TODO
 *
 * @author Emmanuel Bigeon
 *
 */
public class CommandTestingApplication {

    private final PrintWriter writer;
    private final ConsoleTestApplication application;
    private final Thread th;

    /** @throws IOException if the streams cannot be build */
    public CommandTestingApplication() throws IOException {
        final PipedOutputStream src = new PipedOutputStream();
        InputStream in = new PipedInputStream(src);

        application = new ConsoleTestApplication(
                new SystemConsoleManager(System.out, in));
        th = new Thread(new Runnable() {

            @Override
            public void run() {
                application.start();
            }
        });

        th.start();
        writer = new PrintWriter(src, true);
    }

    public void stop() {
        application.exit();
        writer.println();
    }

    public void sendCommand(String cmd) {
        writer.println(cmd);
    }

    /** @param cmd the command
     * @return if the command was added
     * @throws InvalidCommandName if the command name is invalid
     * @see fr.bigeon.gclc.ConsoleApplication#add(fr.bigeon.gclc.command.ICommand) */
    public final boolean add(ICommand cmd) throws InvalidCommandName {
        return application.add(cmd);
    }

    /** @return the application */
    public ConsoleTestApplication getApplication() {
        return application;
    }

    /**
     * 
     */
    public void waitAndStop() {
        writer.println(ConsoleTestApplication.EXIT);
        try {
            th.join();
        } catch (InterruptedException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
}
